#!/usr/bin/python

# load the numbers
def load(filename):
    f = open(filename, 'r')
    data = f.readlines()
    f.close()
    for i in range(len(data)):
        data[i] = int(data[i].strip())
    return data

# bin data in x bins
# should work for any range of integer data and any natural number of bins
# not the fastest way by a long shot
def place(x, data): # note 'bin' is a reserved word for converting int to binary
    bins = {}
    smallest = min(data)
    if not (max(data) - smallest) % x == 0:
        smallest -= smallest % x
    size = (max(data) - smallest) / x
    oldmin = smallest
    oldmax = smallest + size
    for i in range(x):
        bins[(oldmin, oldmax)] = 0
        oldmin = oldmax + 1
        oldmax += size
    for datum in data:
        for key, value in bins.iteritems():
            if datum in range(key[0], key[1]+1):
                bins[key] += 1
                break
    assert sum(bins.values()) == len(data)
    return bins

# display the distribution of the data in a graphic akin to a horizontal histogram
def display(bins):
    for key in sorted(bins.keys()):
        print str(key)+':  '+('*'*bins[key])

display(place(10, load('numerical_data_Blake.txt')))

