#!/usr/bin/python

# load the numbers
def load(filename):
    f = open(filename, 'r')
    data = f.readlines()
    f.close()
    for i in range(len(data)):
        data[i] = int(data[i].strip())
    return data

# bin data in x bins
# should work for any range of integer data and any natural number of bins
# not the fastest way by a long shot
def place(x, data): # note 'bin' is a reserved word for converting int to binary
    bins = {}
    smallest = min(data)
    if not (max(data) - smallest) % x == 0:
        smallest -= smallest % x
    size = (max(data) - smallest) / x
    oldmin = smallest
    oldmax = smallest + size
    for i in range(x):
        bins[(oldmin, oldmax)] = 0
        oldmin = oldmax + 1
        oldmax += size
    for datum in data:
        for key, value in bins.iteritems():
            if datum in range(key[0], key[1]+1):
                bins[key] += 1
                break
    assert sum(bins.values()) == len(data)
    return bins

# display the distribution of the data in a graphic akin to a vertical histogram
# not fast
def display(bins):
    headers = ''
    for key in sorted(bins.keys()):
        headers += str(key)
    row = max(bins.values())
    while row > 0:
        rowstr = ''
        for col in sorted(bins.keys()):
            spacing = ' '*((len(str(col))/2)-1)
            if bins[col] >= row:
                rowstr += spacing + '* ' + spacing
            else:
                rowstr += 2*spacing + '  '
        print rowstr
        row -= 1   
    print headers

display(place(10, load('numerical_data_Blake.txt')))

